// WTLControl.h : Declaration of the CWTLControl

#ifndef __WTLCONTROL_H_
#define __WTLCONTROL_H_

#include "resource.h"       // main symbols

#include <atlctl.h>
#include <atlapp.h>
#include <atlctrls.h>
#include <atlhost.h>
#include <atldlgs.h>
#include <atlctrlw.h>
#include <atlsplit.h>

class CHTMLView : public CWindowImpl<CHTMLView, CAxWindow>
{
public:
	DECLARE_WND_SUPERCLASS(NULL, CAxWindow::GetWndClassName())

	BEGIN_MSG_MAP(CHTMLView)
	END_MSG_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CWTLControl
class ATL_NO_VTABLE CWTLControl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IWTLControl, &IID_IWTLControl, &LIBID_AXCONTROLWSPLITTERSLib>,
	public CComControl<CWTLControl>,
	public IPersistStreamInitImpl<CWTLControl>,
	public IOleControlImpl<CWTLControl>,
	public IOleObjectImpl<CWTLControl>,
	public IOleInPlaceActiveObjectImpl<CWTLControl>,
	public IViewObjectExImpl<CWTLControl>,
	public IOleInPlaceObjectWindowlessImpl<CWTLControl>,
	public IPersistStorageImpl<CWTLControl>,
	public ISpecifyPropertyPagesImpl<CWTLControl>,
	public IQuickActivateImpl<CWTLControl>,
	public IDataObjectImpl<CWTLControl>,
	public IProvideClassInfo2Impl<&CLSID_WTLControl, NULL, &LIBID_AXCONTROLWSPLITTERSLib>,
	public CComCoClass<CWTLControl, &CLSID_WTLControl>
{
public:
	CWTLControl()
	{
		m_bWindowOnly = TRUE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_WTLCONTROL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CWTLControl)
	COM_INTERFACE_ENTRY(IWTLControl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CWTLControl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
END_PROP_MAP()

BEGIN_MSG_MAP(CWTLControl)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	CHAIN_MSG_MAP(CComControl<CWTLControl>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()


// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IWTLControl
public:

	LRESULT OnCreate(UINT, WPARAM, LPARAM, BOOL&)
	{
		AtlAxWinInit();
		//Create the Left and right views
		m_LeftView.Create(m_hWnd, rcDefault, _T("http://www.microsoft.com"),WS_CHILD | WS_VISIBLE | 
            WS_CLIPSIBLINGS | WS_CLIPCHILDREN,WS_EX_STATICEDGE);		

		m_RightView.Create(m_hWnd, rcDefault, _T("http://www.microsoft.com"),WS_CHILD | WS_VISIBLE | 
            WS_CLIPSIBLINGS | WS_CLIPCHILDREN,WS_EX_STATICEDGE);			

		RECT rect; GetClientRect(&rect);
		//create the splitter as a view
		m_splitter.Create(m_hWnd, rect, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN);
			
		//UpdateLayout();
		m_splitter.SetSplitterPanes(m_LeftView, m_RightView);
		GetClientRect(&rect);
		m_splitter.SetSplitterPos((rect.right - rect.left) / 4);
		
		return 0L;
	}
		

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		LPCTSTR pszText = _T("ATL 3.0 : WTLControl");
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszText, 
			lstrlen(pszText));

		return S_OK;
	}
	
	
	CSplitterWindow		m_splitter;
	CHTMLView			m_LeftView;
	CHTMLView			m_RightView;
};

#endif //__WTLCONTROL_H_
